/*! \file KML_Style.h 
 *  \brief: header file for kml_style object
 */

#ifndef _KML_STYLE_H_
#define _KML_STYLE_H_

/*Headers:*/
/*{{{1*/
#include "../../include/include.h"
#include "../../shared/Exceptions/exceptions.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

#include "./KML_StyleSelector.h"
class KML_LineStyle;
class KML_PolyStyle;
/*}}}*/

class KML_Style: public KML_StyleSelector {

	public:

		void* icon;
		void* label;
		KML_LineStyle* line;
		KML_PolyStyle* poly;
		void* balloon;
		void* list;

		/*KML_Style constructors, destructors {{{1*/
		KML_Style();
		~KML_Style();
		/*}}}*/
		/*Object virtual functions definitions:{{{1*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		void  Write(FILE* fid,char* indent);
		void  Read(FILE* fid,char* kstr);
		int   Id(){_error_("Not implemented yet.");};
		int   MyRank(){_error_("Not implemented yet.");};
		void  Marshall(char** pmarshalled_dataset){_error_("Not implemented yet.");};
		int   MarshallSize(){_error_("Not implemented yet.");};
		void  Demarshall(char** pmarshalled_dataset){_error_("Not implemented yet.");};
		int   Enum(){_error_("Not implemented yet.");};
		Object* copy(){_error_("Not implemented yet.");};
		/*}}}*/

};
#endif  /* _KML_STYLE_H */

